
<template>
  <div>
    <button class="button-primary" @click="startUpload"><i class="fa fa-download fa-lg"></i> Carregar Ficheiro{{ multiple ? 's':'' }}</button>
    <input
      class="hidden-input"
      type="file"
      :multiple="multiple"
      ref="uploadInput"
      @change="newFiles"
    />
    <p v-if="message">{{ message }}</p>
  </div>
</template>

<script>
import XLSX from "xlsx";

export default {
  props: {
    multiple: { type: Boolean, default: false }
  },
  data(){
    return {
      message: ''
    }
  },
  methods: {
    startUpload() {
      this.$refs.uploadInput.value = "";
      this.$refs.uploadInput.click();
    },
    newFiles(evt) {
      const files = evt.target.files;

      const loader = e => {
        let data = new Uint8Array(e.target.result);
        let workbook = XLSX.read(data, { type: "array" });
        let ws = workbook.Sheets[workbook.SheetNames[0]];
        this.$emit("newFile", { name: e.target.fileName, sheet: ws });
      };

      files.forEach(f => {
        const reader = new FileReader();
        reader.fileName = f.name.split(".")[0];
        if (!["xlsx", "csv"].includes(f.name.split(".")[1])) {
          this.message = "Tipo de ficheiro não reconhecido!";
        } else {
          this.message = '';
          reader.onload = loader;
          reader.readAsArrayBuffer(f);
        }
      });
    }
  }
};
</script>

<style>
.hidden-input {
  display: none;
}
</style>